var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _colorUtils=_interopRequireDefault(require("../color-utils"));describe("ColorUtils",function(){describe("convertHexFromShorthand",function(){it("should convert shorthand hex to full length hex",function(){expect(_colorUtils.default.convertHexFromShorthand("#037")).toBe("#003377");expect(_colorUtils.default.convertHexFromShorthand("037")).toBe("#003377");});it("should return the same hex if it is already in full length",function(){expect(_colorUtils.default.convertHexFromShorthand("#003377")).toBe("#003377");});it("should return undefined if the hex is invalid",function(){expect(_colorUtils.default.convertHexFromShorthand("#12345")).toBeUndefined();expect(_colorUtils.default.convertHexFromShorthand("12345")).toBeUndefined();});});describe("componentToHex",function(){it("should convert a component value to a two-digit hex",function(){expect(_colorUtils.default.componentToHex(10)).toBe("0a");expect(_colorUtils.default.componentToHex(255)).toBe("ff");});});describe("rgbTOrrggbb",function(){it("should return the same hex if it is already in the correct format",function(){expect(_colorUtils.default.rgbTOrrggbb("#003377")).toBe("#003377");expect(_colorUtils.default.rgbTOrrggbb("#ffffff")).toBe("#ffffff");});it("should convert shorthand hex to full length hex",function(){expect(_colorUtils.default.rgbTOrrggbb("#037")).toBe("#003377");});it("should return undefined if the hex is invalid",function(){expect(_colorUtils.default.rgbTOrrggbb("#12345")).toBeUndefined();});});describe("getRedChannelFromHex",function(){it("should return the red channel value from a valid hex string",function(){expect(_colorUtils.default.getRedChannelFromHex("#003377")).toBe(0);expect(_colorUtils.default.getRedChannelFromHex("#ff0000")).toBe(255);expect(_colorUtils.default.getRedChannelFromHex("#00ff00")).toBe(0);expect(_colorUtils.default.getRedChannelFromHex("#0000ff")).toBe(0);});it("should return 0 if the hex string is invalid",function(){expect(_colorUtils.default.getRedChannelFromHex("#12345")).toBe(0);expect(_colorUtils.default.getRedChannelFromHex("12345")).toBe(0);expect(_colorUtils.default.getRedChannelFromHex("#gg0000")).toBe(0);});});describe("getGreenChannelFromHex",function(){it("should return the green channel value from a valid hex string",function(){expect(_colorUtils.default.getGreenChannelFromHex("#003377")).toBe(51);expect(_colorUtils.default.getGreenChannelFromHex("#ff0000")).toBe(0);expect(_colorUtils.default.getGreenChannelFromHex("#00ff00")).toBe(255);expect(_colorUtils.default.getGreenChannelFromHex("#0000ff")).toBe(0);});it("should return 0 if the hex string is invalid",function(){expect(_colorUtils.default.getGreenChannelFromHex("#12345")).toBe(0);expect(_colorUtils.default.getGreenChannelFromHex("12345")).toBe(0);expect(_colorUtils.default.getGreenChannelFromHex("#gg0000")).toBe(0);});});describe("getBlueChannelFromHex",function(){it("should return the blue channel value from a valid hex string",function(){expect(_colorUtils.default.getBlueChannelFromHex("#003377")).toBe(119);expect(_colorUtils.default.getBlueChannelFromHex("#ff0000")).toBe(0);expect(_colorUtils.default.getBlueChannelFromHex("#00ff00")).toBe(0);expect(_colorUtils.default.getBlueChannelFromHex("#0000ff")).toBe(255);});it("should return 0 if the hex string is invalid",function(){expect(_colorUtils.default.getBlueChannelFromHex("#12345")).toBe(0);expect(_colorUtils.default.getBlueChannelFromHex("12345")).toBe(0);expect(_colorUtils.default.getBlueChannelFromHex("#gg0000")).toBe(0);});});describe("getAlphaChannelFromHex",function(){it("should return the alpha channel value from a valid hex string",function(){expect(_colorUtils.default.getAlphaChannelFromHex("#003377")).toBe(null);expect(_colorUtils.default.getAlphaChannelFromHex("#ff0000")).toBe(null);expect(_colorUtils.default.getAlphaChannelFromHex("#00ff00")).toBe(null);expect(_colorUtils.default.getAlphaChannelFromHex("#0000ff")).toBe(null);expect(_colorUtils.default.getAlphaChannelFromHex("#003377ff")).toBe(255);expect(_colorUtils.default.getAlphaChannelFromHex("#ff0000ff")).toBe(255);expect(_colorUtils.default.getAlphaChannelFromHex("#00ff00ff")).toBe(255);expect(_colorUtils.default.getAlphaChannelFromHex("#0000ffff")).toBe(255);});it("should return null if the hex string does not have an alpha channel",function(){expect(_colorUtils.default.getAlphaChannelFromHex("#12345")).toBe(null);expect(_colorUtils.default.getAlphaChannelFromHex("12345")).toBe(null);expect(_colorUtils.default.getAlphaChannelFromHex("#gg0000")).toBe(null);});});describe("applyDarknessToHex",function(){it("should apply darkness to each color channel and return the hex with alpha applied",function(){expect(_colorUtils.default.applyDarknessToHex("#003377",50)).toBe("#004db3ff");expect(_colorUtils.default.applyDarknessToHex("#ff0000",25)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToHex("#00ff00",75)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToHex("#0000ff",10)).toBe("#0000ffff");});it("should return the same hex if the darkness percentage is 0",function(){expect(_colorUtils.default.applyDarknessToHex("#003377",0)).toBe("#003377ff");expect(_colorUtils.default.applyDarknessToHex("#ff0000",0)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToHex("#00ff00",0)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToHex("#0000ff",0)).toBe("#0000ffff");});it("should return the same hex if the darkness percentage is 100",function(){expect(_colorUtils.default.applyDarknessToHex("#003377",100)).toBe("#0066eeff");expect(_colorUtils.default.applyDarknessToHex("#ff0000",100)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToHex("#00ff00",100)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToHex("#0000ff",100)).toBe("#0000ffff");});it("should return the same hex if the hex is invalid",function(){expect(_colorUtils.default.applyDarknessToHex("#12345",50)).toBe("#12345");expect(_colorUtils.default.applyDarknessToHex("12345",50)).toBe("12345");expect(_colorUtils.default.applyDarknessToHex("#gg0000",50)).toBe("#gg0000");});});describe("applyDarknessToColor",function(){it("should apply darkness to each color channel and return the hex with alpha applied",function(){expect(_colorUtils.default.applyDarknessToColor("#003377",50)).toBe("#004db3ff");expect(_colorUtils.default.applyDarknessToColor("#ff0000",25)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToColor("#00ff00",75)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToColor("#0000ff",10)).toBe("#0000ffff");});it("should return the same hex if the darkness percentage is 0",function(){expect(_colorUtils.default.applyDarknessToColor("#003377",0)).toBe("#003377ff");expect(_colorUtils.default.applyDarknessToColor("#ff0000",0)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToColor("#00ff00",0)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToColor("#0000ff",0)).toBe("#0000ffff");});it("should return the same hex if the darkness percentage is 100",function(){expect(_colorUtils.default.applyDarknessToColor("#003377",100)).toBe("#0066eeff");expect(_colorUtils.default.applyDarknessToColor("#ff0000",100)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToColor("#00ff00",100)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToColor("#0000ff",100)).toBe("#0000ffff");});it("should return the same hex if the color is invalid",function(){expect(_colorUtils.default.applyDarknessToColor("#12345",50)).toBe("#12345");expect(_colorUtils.default.applyDarknessToColor("12345",50)).toBe("12345");expect(_colorUtils.default.applyDarknessToColor("#gg0000",50)).toBe("#gg0000");});it("should convert rgba color to hex and apply darkness",function(){expect(_colorUtils.default.applyDarknessToColor("rgba(0,51,119,1)",50)).toBe("#004db3ff");expect(_colorUtils.default.applyDarknessToColor("rgba(255,0,0,1)",25)).toBe("#ff0000ff");expect(_colorUtils.default.applyDarknessToColor("rgba(0,255,0,1)",75)).toBe("#00ff00ff");expect(_colorUtils.default.applyDarknessToColor("rgba(0,0,255,1)",10)).toBe("#0000ffff");expect(_colorUtils.default.applyDarknessToColor("#ffffff",10)).toBe("#ffffffff");expect(_colorUtils.default.applyDarknessToColor("rgba",10)).toBe("");});});describe("getDarknessScore",function(){it("should return the darkness score for a given color",function(){expect(_colorUtils.default.getDarknessScore("#003377")).toBeCloseTo(0.829,3);expect(_colorUtils.default.getDarknessScore("#ff0000")).toBeCloseTo(0.701,3);expect(_colorUtils.default.getDarknessScore("#00ff00")).toBeCloseTo(0.413,3);expect(_colorUtils.default.getDarknessScore("#0000ff")).toBeCloseTo(0.886,3);expect(_colorUtils.default.getDarknessScore("#F5F5DC")).toBeCloseTo(0.05,3);expect(_colorUtils.default.getDarknessScore("#FFE4B5")).toBeCloseTo(0.095,3);expect(_colorUtils.default.getDarknessScore("#ADD8E6")).toBeCloseTo(0.197,3);expect(_colorUtils.default.getDarknessScore("#fff0")).toBeCloseTo(0,3);});});describe("determineTextColor",function(){it("should return white for a dark color",function(){expect(_colorUtils.default.determineTextColor("#000000")).toBe("#FFFFFF");expect(_colorUtils.default.determineTextColor("#333333")).toBe("#FFFFFF");expect(_colorUtils.default.determineTextColor("#666666")).toBe("#FFFFFF");});it("should return black for a light color",function(){expect(_colorUtils.default.determineTextColor("#ffffff")).toBe("#262626");expect(_colorUtils.default.determineTextColor("#cccccc")).toBe("#262626");expect(_colorUtils.default.determineTextColor("#dddddd")).toBe("#262626");});it("should return black for a color with darkness score less than 0.4",function(){expect(_colorUtils.default.determineTextColor("#F5F5DC")).toBe("#262626");expect(_colorUtils.default.determineTextColor("#FFE4B5")).toBe("#262626");expect(_colorUtils.default.determineTextColor("#ADD8E6")).toBe("#262626");expect(_colorUtils.default.determineTextColor("#fff0")).toBe("#262626");expect(_colorUtils.default.determineTextColor("#FFF0")).toBe("#262626");});it("should return white for a color with darkness score greater than or equal to 0.4",function(){expect(_colorUtils.default.determineTextColor("#003377")).toBe("#FFFFFF");expect(_colorUtils.default.determineTextColor("#ff0000")).toBe("#FFFFFF");expect(_colorUtils.default.determineTextColor("#00ff00")).toBe("#FFFFFF");});});});
//# sourceMappingURL=color-utils.test.js.map